flask1/views/ventas.py
# coding=utf-8
from ._common import *

bp_ventas = Blueprint('ventas', __name__, url_prefix='/ventas')

'''menu_listadoventas
exportar_ventas
menu_agregelimtipoventa
menu_eliminarventa
menu_ingresarpedido
vender_pedido
'''
@bp_ventas.route("/listadoventas", methods=['GET'])
@login_required
def menu_listadoventas():
    
    return make_response(render_template(
        'menu/ventas/listadoventas.html',
        ventapikas = get_ventas(request.args),
        ventatipos = get_ventatipos(),
        pikas = get_pikas(),
        filtrado = hasquery(request.args)
    ))
    
@bp_ventas.route("/exportar/ventas.csv", methods=['GET'])
@login_required
def exportar_ventas():
    ventas = get_ventas(request.args)

    ex = CsvExporter('ventas.csv')
    ex.writeHeaders('Id,Fecha,Fecha pedido,Tipo,Comentario,Pika,Cantidad')
    last_venta_id = 0
    for vp in ventas:
        if last_venta_id != vp.venta_id:
            v = vp.venta
            vals = [
                v.id,
                v.fecha,
                v.fecha_pedido or '',
                v.ventatipo.nombre,
                v.comentario,
                '',
                ''
            ]
        vals[5] = vp.pika.nombre
        vals[6] = vp.cantidad
        ex.writeVals(vals)
            
    return ex.send()

@bp_ventas.route("/agregelimtipoventa", methods = ['GET', 'POST'])
@login_required
def menu_agregelimtipoventa():
    if request.method == "GET":
        
        return make_response(render_template(
            'menu/ventas/agregelimtipoventa.html',
            ventatipos = get_ventatipos()
        ))
        
    else:  # request.method == "POST":
        print('post form:', request.form)

        try:                
            if request.form['operation'] == 'add':
                
                checkparams(request.form, ('nombretipoven',))
                add_ventatipo(request.form['nombretipoven'])
                
            elif request.form['operation'] == 'delete':
                
                checkparams(request.form, ('tipo',))
                del_ventatipo(int(request.form['tipo']))
                
            else:
                raise Exception('Operación inválida')                        
        except Exception as e:
            return str(e), 400

        return ''

@bp_ventas.route("/eliminarventa", methods=['GET', 'POST'])
@login_required
def menu_eliminarventa():
    if request.method == "GET":
        
        return make_response(render_template(
            'menu/ventas/eliminarventa.html',
            ventas = get_ventas_format_select(),
            pedidos = get_pedidos_format_select()
        ))

    else:  # request.method == "POST":
        print('post form:', request.form)

        try:
            operation = request.form['operation']
    
            if operation == 'delete_pedido':
                del_pedido(request.form.get('pedido'))
            elif operation == 'delete_venta':
                del_venta(request.form.get('venta'))
            else:
                raise Exception('Operación inválida')
        except Exception as e:
            return str(e), 400

        return ''

@bp_ventas.route("/ingresarpedido", methods = ['GET', 'POST'])
@login_required
def menu_ingresarpedido():
    if request.method == "GET":
        urgentes_all = get_urgentes()
        urgentes = {}
        for u in urgentes_all:
            urgentes[u.venta_id] = True
        
        return make_response(render_template(
            'menu/ventas/ingresarpedido.html',
            ventatipos = get_ventatipos(),
            pikas = get_pikas(),
            ventapikas = get_pedidos(),
            urgentes = urgentes
        ))
        
    else:  # request.method == "POST":
        print('post form:', request.form)

        try:
            checkparams(request.form, ('tipo', 'pika', 'cantidad'))
            
            pikas = request.form.getlist('pika')
            cants = request.form.getlist('cantidad')
            tipo = request.form['tipo']
            comentario = request.form['comentario'] if 'comentario' in request.form else None
            vendido = 'vendido' in request.form
            
            warns = add_pedido(vendido, pikas, cants, tipo, comentario)
    
            if warns:
                return 'La operación se realizó pero algunos pikas no van a tener stock para la venta:<br>- ' + '<br>- '.join(warns)
        except Exception as e:
            return str(e), 400

        return ''

@bp_ventas.route("/vender_pedido", methods = ['POST'])
@login_required
def menu_vender_pedido():
    print('post form:', request.form)

    try:
        checkparams(request.form, ('venta_id',))
        vender_pedido(request.form['venta_id'])        
    except Exception as e:
        return str(e), 400
    
    return ''

@bp_ventas.route("/pedido_urgente", methods = ['POST'])
@login_required
def menu_pedido_urgente():
    print('post form:', request.form)

    try:
        checkparams(request.form, ('venta_id',))
        tog_urgente(request.form['venta_id'])        
    except Exception as e:
        return str(e), 400
    
    return ''

    

flask1/templates/menu/ventas/agregelimtipoventa.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.card('Agregar tipo de venta', size=6)  %}
<input type="hidden" name="operation" value="add">
<!-- BOTONES -->
<div class="form-group row">
    <div class="col-sm-6">
        <input type="text" name="nombretipoven" class="form-control" placeholder="Nombre" required>
    </div>
    <div class="col-sm-6">
        <button type="submit" class="btn btn-primary btn-block">Agregar</button>
    </div>
</div>
{% endcall %}
{% call forms.card('Eliminar tipo de venta', size=6)  %}
<input type="hidden" name="operation" value="delete">
<div class="alert alert-warning fade show">
    <p class="mb-0">Advertencia: esta operación eliminará el tipo de venta y todos sus datos asociados (ventas con este tipo de venta)</p>
</div>
<!-- Insumo -->
<div class="form-group row">
    {{ forms.input_select(6, "tipo", "Elija un tipo de venta", required=1) }}
    <div class="col-sm-6">
        <button type="submit" class="btn btn-primary btn-block" onclick="if (!confirm('¿Está segurx que desea eliminar este tipo de venta y todas sus ventas asociadas?')) event.preventDefault()">Eliminar</button>
    </div>
</div>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {

    regFormValid();

    tiposdata = {{ forms.dataToJsArr(ventatipos) }};
    sel2('.select2-single[name=tipo]', 'Tipo', tiposdata);
    
});
</script>
{% endblock %}

flask1/templates/menu/ventas/eliminarventa.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.card('Eliminar pedido', size=6)  %}
<input type="hidden" name="operation" value="delete_pedido">
<div class="alert alert-warning fade show">
    <p class="mb-0">Advertencia: esta operación eliminará el pedido.</p>
</div>
<!-- Venta -->
<div class="form-group row">
    {{ forms.input_select(12, "pedido", "Elija un pedido", required=1) }}
</div>
<div class="form-group row">
    <div class="col">
        <button type="submit" class="btn btn-primary btn-block" onclick="if (!confirm('¿Está segurx que desea eliminar este pedido?')) event.preventDefault()">Eliminar</button>
    </div>
</div>
{% endcall %}

{% call forms.card('Eliminar venta', size=6)  %}
<input type="hidden" name="operation" value="delete_venta">
<div class="alert alert-warning fade show">
    <p class="mb-0">Advertencia: esta operación eliminará la venta y todos sus datos asociados (devuelve stock de pikas)</p>
</div>
<!-- Venta -->
<div class="form-group row">
    {{ forms.input_select(12, "venta", "Elija una venta", required=1) }}
</div>
<div class="form-group row">
    <div class="col">
        <button type="submit" class="btn btn-primary btn-block" onclick="if (!confirm('¿Está segurx que desea eliminar esta venta?')) event.preventDefault()">Eliminar</button>
    </div>
</div>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {

    regFormValid(false, function(){ setTimeout('location.reload();', 2000) });

    ventasdata = {{ forms.dataToJsArrMulti(ventas, 'fecha', 'comentario') }};
    sel2('.select2-single[name=venta]', 'Venta', ventasdata);

    pedidosdata = {{ forms.dataToJsArrMulti(pedidos, 'fecha', 'comentario') }};
    sel2('.select2-single[name=pedido]', 'Pedido', pedidosdata);

});
</script>
{% endblock %}

flask1/templates/menu/ventas/ingresarpedido.html
{% extends '_maingui.html' %}

{% block styles %}
<style>
.listado_pedidos td .btn{
	width: 30px;
	height: 30px;
}
.listado_pedidos td .btn-secondary:hover{
	background-color: white;
	color: black;
}
.listado_pedidos td .btn-danger:hover{
	background-color: white;
	color: #dc3545;
}
</style>
{% endblock %}

{% block content %}
{% call forms.card('Ingresar pedido')  %}
<!-- Tipo y Comentario -->
<div class="form-group row">
    {{ forms.input_select(5, "tipo", "Elija un tipo", required=1) }}
    <div class="col-sm-7">
        <input type="text" name="comentario" class="form-control" placeholder="Comentario">
    </div>
</div>
<!-- Pikas -->
<div class="form-group row addable">
    {{ forms.input_select(8, "pika", "Elija un pika", required=1) }}
	{{ forms.input_number(4, 'cantidad', min=1, required=1, readonly=0) }}
</div>
<!-- BOTONES -->
<div class="form-group row">
    <div class="col-sm-3">
        <button type="button" id="btnAdd" class="btn btn-success btn-block"> + </button>
    </div>
    <div class="col-sm-5">
        <button type="submit" class="btn btn-primary btn-block">Ingresar</button>
    </div>
    <div class="col-sm-4 my-auto pl-5 pt-3 pt-sm-0">
	    <input type="checkbox" class="form-check-input" id="vendido" name="vendido">
	    <label class="form-check-label ml-2 align-middle" for="vendido">Vendido</label>
    </div>
</div>
{% endcall %}

{% call forms.card('Listado pedidos', css_class='listado_pedidos mt-3')  %}
<table class="table table-sm table-striped table-hover">
  <thead>
    <tr>
      <th>Fecha pedido</th>
      <th>Tipo</th>
      <th>Comentario</th>
      <th>Pika</th>
      <th>Cant.</th>
      <th>Ven.</th>
      <th>Urg.</th>
    </tr>
  </thead>
  <tbody>
    {% set vars = {'last_ventid': 0} %}
    {% for ventapi in ventapikas %}
        <tr>
			<input type="hidden" class="venta_id" value="{{ventapi.venta_id}}">
			{% if vars.last_ventid != ventapi.venta_id %}
                <td>{{ventapi.venta.fecha_pedido.strftime("%d/%m/%Y %H:%M")}}</td>
                <td>{{ventapi.venta.ventatipo.nombre}}</td>
                <td>{{ventapi.venta.comentario}}</td>
				{# actualizamos last_ventid en el prox if #}
            {% else %}
                <td></td>
                <td></td>
                <td></td>
            {% endif %}
            <td>{{ventapi.pika.nombre}}</td>
            <td>{{ventapi.cantidad}}</td>
            {% if vars.last_ventid != ventapi.venta_id %}
	            <td class="">
					<button type="button" class="btnVender btn btn-secondary btn-block p-0">✓</button>
				</td>
	            <td class="">
					<button type="button" class="btnUrgencia btn btn-{{ 'danger' if ventapi.venta_id in urgentes else 'secondary' }} btn-block p-0">!</button>
				</td>
                {% if vars.update({'last_ventid': ventapi.venta_id}) %}{% endif %}
            {% else %}
                <td></td>
                <td></td>
            {% endif %}
        </tr>
    {% endfor %}
</table>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {

    regFormValid(true, function(){ setTimeout('location.reload();', 3000) });

    tiposdata = {{ forms.dataToJsArr(ventatipos) }};
    sel2('.select2-single[name=tipo]', 'Tipo', tiposdata);

    pikasdata = {{ forms.dataToJsArr(pikas) }};
    pikarowhtml = $('.addable.form-group.row')[0].outerHTML.replace(/ required/g, '');
    sel2('.select2-single[name=pika]', 'Pika', pikasdata);

    $('#btnAdd').click(function(){
        $('.form-group.row').last().before(pikarowhtml);
        sel2('.select2-single[name=pika]', 'Pika', pikasdata);
    });

    $('.btnVender').click(function(){
		if (!confirm('¿Está seguro que desea vender este pedido?'))
			return;

		var table = $(this).parents('table');
		var parent_row = $(this).parents('tr')
		var venta_id = parent_row.children('.venta_id').val();
		console.log(venta_id)
        var ventaspikas = table.find('.venta_id[value='+venta_id+']')
		var ventaspikas_rows = ventaspikas.parents('tr');

		lockForm(table)
        $.ajax({
             type: "POST",
             url: 'vender_pedido',
             data: { venta_id: venta_id },
             success: function(r){
                unlockForm(table);
				console.log(ventaspikas, table.find('.venta_id[value='+venta_id+']'), table.find('.venta_id'))

				ventaspikas_rows.addClass('table-success')
				ventaspikas_rows.fadeOut(500, function() {
					$(this).remove();
				});
             },
             error: function(r){
                unlockForm(table);
				ventaspikas_rows.addClass('table-danger')
				alert(r.responseText)
				setTimeout(function(){ ventaspikas_rows.removeClass('table-danger'); }, 700)
             }
        });
	});

    $('.btnUrgencia').click(function(){
		var $this = $(this)
		var isurgent = $this.hasClass('btn-danger')

		// Saltar validación de urgencia porque lo usan mucho
		/*if (isurgent){
			if (!confirm('¿Está segurx que desea sacarle la urgencia a este pedido?'))
				return;
		}else{
			if (!confirm('¿Está segurx que desea marcar este pedido como urgente?'))
				return;
		}*/

		var table = $this.parents('table');
		var parent_row = $this.parents('tr')

		var venta_id = parent_row.children('.venta_id').val();
		console.log(venta_id, isurgent)

        var ventaspikas = table.find('.venta_id[value='+venta_id+']')
		var ventaspikas_rows = ventaspikas.parents('tr');

		lockForm(table)
        $.ajax({
             type: "POST",
             url: 'pedido_urgente',
             data: { venta_id: venta_id },
             success: function(r){
                unlockForm(table);

				if (isurgent){
					$this.removeClass('btn-danger')
					$this.addClass('btn-secondary')
				}else{
					$this.removeClass('btn-secondary')
					$this.addClass('btn-danger')
				}
				ventaspikas_rows.addClass('table-success')
				setTimeout(function(){ ventaspikas_rows.removeClass('table-success'); }, 900)
             },
             error: function(r){
                unlockForm(table);
				ventaspikas_rows.addClass('table-danger')
				alert(r.responseText)
				setTimeout(function(){ ventaspikas_rows.removeClass('table-danger'); }, 900)
             }
        });
	});
});
</script>
{% endblock %}

flask1/templates/menu/ventas/listadoventas.html
{% extends '_maingui.html' %}

{% block content %}
{% call forms.cardNoForm('Listado de ventas')  %}
{% if filtrado %}
<div class="alert alert-info fade show">
    <p class="mb-0">(La lista está filtrada. Para eliminar filtro, filtrar con todos los campos vacíos)</p>
</div>
{% endif %}
<form novalidate method="GET">
    <a id="exportar-btn" class="btn btn-primary btn-block" href="{{url_for('ventas.exportar_ventas')}}">Exportar a CSV</a>
</form>
<form novalidate method="GET" class="mt-2">
    <h5>Filtrar listado</h5>
    <!-- Tipo y Comentario-->
    <div class="form-group row">
    {{ forms.input_select(4, "tipo", "", required=0) }}
        <div class="col-sm-8">
            <input type="text" name="comentario" class="form-control" placeholder="Comentario">
        </div>
    </div>
    <!-- Fechas d-h -->
    <div class="form-group row">
        <div class="col-sm-6">
            <input type="text" class="form-control" name="fechadesde" placeholder="Fecha desde">
        </div>
        <div class="col-sm-6">
            <input type="text" class="form-control" name="fechahasta" placeholder="Fecha hasta">
        </div>
    </div>
    <!-- Pika y BOTON-->
    <div class="form-group row">
    {{ forms.input_select(4, "pika", "Elija un pika", required=0) }}
        <div class="col-sm-8">
            <button type="submit" class="btn btn-primary btn-block">Filtrar</button>
        </div>
    </div>
</form>
<div class="table-wrapper" style="overflow-x: scroll;">
	<table class="table table-sm table-striped table-hover">
	  <thead>
	    <tr>
	      <th>Fecha venta</th>
	      <th>Fecha pedido</th>
	      <th>Tipo</th>
	      <th>Comentario</th>
	      <th>Pika</th>
	      <th>Cantidad</th>
	    </tr>
	  </thead>
	  <tbody>
	    {% set vars = {'last_ventid': 0} %}
	    {% for ventapi in ventapikas %}
	        <tr>
	            {% if vars.last_ventid != ventapi.venta.id %}
	                <td>{{ventapi.venta.fecha.strftime("%d/%m/%Y %H:%M")}}</td>
	                <td>{{ventapi.venta.fecha_pedido.strftime("%d/%m/%Y %H:%M") if ventapi.venta.fecha_pedido else 'Sin dato'}}</td>
	                <td>{{ventapi.venta.ventatipo.nombre}}</td>
	                <td>{{ventapi.venta.comentario}}</td>
	                {% if vars.update({'last_ventid': ventapi.venta.id}) %}{% endif %}
	            {% else %}
	                <td></td>
	                <td></td>
	                <td></td>
	                <td></td>
	            {% endif %}
	            <td>{{ventapi.pika.nombre}}</td>
	            <td>{{ventapi.cantidad}}</td>
	        </tr>
	    {% endfor %}
	</table>
</div>
{% endcall %}
{% endblock %}

{% block js %}
<script type="text/javascript">
$(function() {
    querystr = window.location.href.split('?')[1]
    if (querystr)
        $('#exportar-btn').attr('href', $('#exportar-btn').attr('href')+'?'+querystr)

    $('input[name="fechadesde"]').add('input[name="fechahasta"]').datepicker()

    tiposdata = {{ forms.dataToJsArr(ventatipos) }};
    sel2('.select2-single[name=tipo]', 'Tipo', tiposdata);

    pikasdata = {{ forms.dataToJsArr(pikas) }};
    sel2('.select2-single[name=pika]', 'Pika', pikasdata);
});
</script>
{% endblock %}